c Package: PINOCCHIO 1.1
c
c Written by Pierluigi Monaco, Tom Theuns and Giuliano Taffoni
c Copyright (C) 2001
c
      program fragment
c
c fragments the collapsed medium into objects
c displacing the points in the Eulerian space
c
      implicit none
#ifdef v64
      include 'param_64.inc'
#endif
#ifdef v128
      include 'param_128.inc'
#endif
#ifdef v256
      include 'param_256.inc'
#endif
c      include 'param.inc'
      include 'link.inc'
      include 'out.inc'
      include 'merger_new.inc'
#ifdef SPIN
      include 'groups_spin.inc'
#else
      include 'groups.inc'
#endif
c
      real Fmax(ng,ng,ng),vx(ngtot),vy(ngtot),vz(ngtot)
      common /max/Fmax,vx,vy,vz
      real lbox,omega0,omlam,nsp,s8,h,csp
      common /cosmology/omega0,omlam,nsp,csp,s8,h
c
      real Flim,z,Mtot,Mpart
      common /particle_mass/Mpart
      integer out_flag,stop_flag
      character*6 kernel
      common /per_mf/kernel
      integer ilim1,ilim2,jlim1,jlim2,klim1,klim2
      real xlim1,xlim2,ylim1,ylim2,zlim1,zlim2
      common /limits/ilim1,ilim2,jlim1,jlim2,klim1,klim2
     $     ,xlim1,xlim2,ylim1,ylim2,zlim1,zlim2
      integer i,param_flag
      character run*6,dir*5
      integer ipos
      real var_grid,r,v,vt
      real grow,Radius,aM_star
      external grow,Radius,aM_star,ipos
      integer filter,flag_ps
      common /smoothing_filter/filter
      real delta_c
      common /ps/delta_c,flag_ps
c
      real f_m,f_rm,f_a,f_s,f_ra,espo,grid
      common /per_virial/f_m,f_rm,f_a,f_s,f_ra,espo,grid
c
c Init
c
      print *,'Runnung version 1.1 (alpha)'
#ifdef SPIN
      print *,'This version is compiled WITH the SPIN option'
      seed=-33343
#else
      print *,'This version is compiled WITHOUT the SPIN option'
#endif
#ifdef PAIRS
      print *,'This version is compiled WITH the PAIRS option'
#else
      print *,'This version is compiled WITHOUT the PAIRS option'
#endif
      print *,'This version is compiled with a resolution of ',ng,' cube'

      MASSMIN=10
      open(21,file='fragment.info',status='old')
      read(21,'(a6)')run
      print *,'run: ',run
      dir='Data/'
      include 'run_info.inc'
      call flush(6)
c
      open(10,file=run//'.var',status='old')
      do i=1,nrsmax+1
         read(10,*,end=53)r,v,vt
         if (r.eq.0.) goto 54
      enddo
 53   print *,run//'.var file not existent or corrupted'
      stop
 54   var_grid=vt
      grid=lbox/float(ng)
      close(10)
c
      call normalization()
      filter=2
      delta_c=1.686
      flag_ps=0
      call Lambda_start()
      call grow_start()
      call scale_start()
c
c Reads the Fmax and vmax matrices
c
      call read_Fmax(lbox,dir,run)
      call flush(6)
c
c Sorts the Fmax matrix
c
      call index_sort(ngtot,Fmax,index)
      print *,'Sorting done'
      call flush(6)
c
c loop
c
 1    continue
c
      read(21,'(a6)')kernel
      print *,'kernel for output files: '//kernel
      open(31,file='frag.'//kernel//'.out',status='unknown')
      print *,'Parameters and infos will be written in the file frag.'//kernel//'.out'
      write(31,'(a9,f10.4)')'lbox   = ',lbox
      write(31,'(a9,f10.4)')'omega0 = ',omega0
      write(31,'(a9,f10.4)')'omlam  = ',omlam
      write(31,'(a9,f10.4)')'nsp    = ',nsp
      write(31,'(a9,f10.4)')'s8     = ',s8
      write(31,'(a9,f10.4)')'h      = ',h
c
      read(21,*)z
      write(31,31)'z    = ',z
      Flim=1./grow(z)
      write(31,31)'Flim = ',Flim
      read(21,*)nout
      write(31,32)'nout = ',nout
      read(21,*)(zout(i),i=1,nout)
      do i=1,nout
         fout(i)=1./grow(zout(i))
      enddo
      write(31,31)'zout = ',(zout(i),i=1,nout)
      write(31,31)'fout = ',(fout(i),i=1,nout)
c
c     0: default parameters
c     1: specify f_a
c     2: specify all parameters
c
      read(21,*)param_flag
      if (param_flag.eq.0) then
         write(31,*)'Parameters are default'
         f_m  = 0.35
         f_rm = 0.70
         f_s  = 0.06
         f_a  = 0.22 + (log10(var_grid/grid) - 0.36) * 0.11
         f_a  = min (f_a,0.26)
         f_a  = max (f_a,0.22)
         f_ra = 0.40 - (f_a - 0.22) * 3.5
      else if (param_flag.eq.1) then
         write(31,*)'f_a is specified, other parameters are default'
         read(21,*)f_a
         f_m  = 0.35
         f_rm = 0.70
         f_s  = 0.06
         f_ra = 0.40 - (f_a - 0.22) * 3.5
      else if (param_flag.eq.2) then
         write(31,*)'All parameters are specified'
         read(21,*)f_m,f_rm,f_a,f_ra,f_s
      else
         print *,'Incorrect parameter flag'
         print *,'Please correct fragment.info and press return'
         read (*,'(a)')
         close(21)
         close(31)
         open(21,file='fragment.info',status='old')
         read(21,'(a6)')run
         goto 1
      endif         
c
      espo=1.7
c
      write(31,31)'f_m  = ',f_m
      write(31,31)'f_a  = ',f_a
      write(31,31)'f_rm = ',f_rm
      write(31,31)'f_ra = ',f_ra
      write(31,31)'f_s  = ',f_s
      write(31,31)'sig2 = ',var_grid/grid
 31   format(a7,10(3x,f6.3))
c
      read(21,*)out_flag
      write(31,32)'outfl= ',out_flag
      read(21,*)stop_flag
      write(31,32)'stop = ',stop_flag
      call flush(6)
      call flush(31)
c
c Looks for limits
c
      read(21,*)ilim1
      if (ilim1.ne.0) then
         read(21,*,end=7)xlim1,xlim2
         read(21,*,end=7)ylim1,ylim2
         read(21,*,end=7)zlim1,zlim2
         ilim1=ipos(xlim1,ng,lbox)
         ilim2=ipos(xlim2,ng,lbox)
         jlim1=ipos(ylim1,ng,lbox)
         jlim2=ipos(ylim2,ng,lbox)
         klim1=ipos(zlim1,ng,lbox)
         klim2=ipos(zlim2,ng,lbox)
         write(31,*)'The liminting coordinates are:'
         write(31,*)ilim1,ilim2
         write(31,*)jlim1,jlim2
         write(31,*)klim1,klim2
         goto 8
      else
         write(31,*)'No limits set, the whole box with PBCs will be considered'
         goto 8
      endif
 7    print *,'Limit flag set !=0 but limits not given'
      print *,'Please correct fragment.info and press return'
      read (*,'(a)')
      close(21)
      close(31)
      open(21,file='fragment.info',status='old')
      read(21,'(a6)')run
      goto 1
c
 8    close(21)
      print *,'file fragment.info read'
 32   format(a7,3x,i2)
      call flush(6)
      call flush(31)
c
      Mtot=2.778e11*h**2*omega0*lbox**3
      Mpart=Mtot/float(ngtot)
      write(31,*)'Mpart    = ',Mpart
      write(31,*)'Mtot     = ',Mtot
      write(31,*)'M*       = ',aM_star(z)
      write(31,*)'Mtot/M*  = ',Mtot/aM_star(z)
      write(31,*)'M*/Mpart = ',aM_star(z)/Mpart
      call flush(6)
      call flush(31)
c
c Generates the group catalogue at Flim
c
      call groups(Flim,lbox,out_flag)
c
c Writes out the results
c
      call out_write(lbox,z,out_flag)
c
c Mass function
c
      call mf(lbox,z)
c
c Bye!
c
      close(31)
      if (stop_flag.eq.0) then
         print *,'Save fragment.info file and press return'
         read (*,'(a)')
         open(21,file='fragment.info',status='old')
         read(21,'(a6)')run
         goto 1
      endif
      end
c
c
c
      subroutine read_Fmax(lbox,dir,run)
c
c Reads the Fmax and vmax matrices
c
      implicit none
#ifdef v64
      include 'param_64.inc'
#endif
#ifdef v128
      include 'param_128.inc'
#endif
#ifdef v256
      include 'param_256.inc'
#endif
c      include 'param.inc'
c
      integer i
      real Fmax(ngtot),vx(ngtot),vy(ngtot),vz(ngtot),lbox,c
      common /max/Fmax,vx,vy,vz
      character*80 nome,dir*5,run*6,label*3
c
      label='vmx'
c
      nome=dir//'Fmax.ell.'//run//'.out'
      open(10,file=nome,status='old',form='unformatted')
      read(10)Fmax
      close(10)
      print *,'Read file '//nome
      call flush(6)
c
      nome=dir//label//'x.ell.'//run//'.out'
      open(10,file=nome,status='old',form='unformatted')
      read(10)vx
      close(10)
      print *,'Read file '//nome
      call flush(6)
c
      nome=dir//label//'y.ell.'//run//'.out'
      open(10,file=nome,status='old',form='unformatted')
      read(10)vy
      close(10)
      print *,'Read file '//nome
      call flush(6)
c
      nome=dir//label//'z.ell.'//run//'.out'
      open(10,file=nome,status='old',form='unformatted')
      read(10)vz
      close(10)
      print *,'Read file '//nome
      call flush(6)
c
      c=float(ng)/lbox
      do i=1,ngtot
         vx(i)=vx(i)*c
         vy(i)=vy(i)*c
         vz(i)=vz(i)*c
      enddo
c
      return
      end
c
c
c
      subroutine groups(Flim,lbox,out_flag)
c
c Fragment the collapsed medium into groups
c
      implicit none
#ifdef v64
      include 'param_64.inc'
#endif
#ifdef v128
      include 'param_128.inc'
#endif
#ifdef v256
      include 'param_256.inc'
#endif
c      include 'param.inc'
      include 'link.inc'
      include 'out.inc'
      include 'merger_new.inc'
#ifdef SPIN
      include 'groups_spin.inc'
#else
      include 'groups.inc'
#endif
c
      integer nv
      parameter (nv=6)
      integer merge(nv,nv)
      real Fmax(ngtot),vx(ngtot),vy(ngtot),vz(ngtot),Flim
      common /max/Fmax,vx,vy,vz
      integer NMERG
      real lbox
c
c
      integer iout
      integer ngsq,nn,i,j,k,mmax,ifil,indx
      integer neigh(nv),neigrp
      integer igrp,ia,iz,in,kk,i1,i2,j1,j2,k1,k2,accrg
      integer ipbc,merge_counter
      integer fil_list(3,nv)
      integer nf,to_group,accgrp,ig1,ig2
      integer ngr_ex,accrflag,nstep,nmerge,nstep_p,perc
      integer merge_flag,nwei1,nwei2,out_flag
      real distance,pbc,d2,r2
      real ratio,best_ratio
      logical mask(-1:1,-1:1,-1:1)
      integer ilim1,ilim2,jlim1,jlim2,klim1,klim2
      real xlim1,xlim2,ylim1,ylim2,zlim1,zlim2
      common /limits/ilim1,ilim2,jlim1,jlim2,klim1,klim2
     $     ,xlim1,xlim2,ylim1,ylim2,zlim1,zlim2
      external distance,pbc,ipbc
      integer nm(6),nmeff,ig3,small,large
      real inverse_grow
      external inverse_grow
c
#ifdef PAIRS
      integer npair,njmax
      parameter(npair=1e6)
      integer pairs(2,npair),nptm,npmerge,njump,mmin_pair
      real Fold,deltaF,Fstart
#endif
c
c Initializations
c
      NMERG=0                   ! NUMBER OF MAJOR MERGER EVENTS
      ngroups=1                 ! number of groups + filaments
      accrg=0                   ! number of accreting events on groups
      nwei1=0                   ! number of points not accreted at merger
                                !   at first attempt
      nwei2=0                   ! number of points never accreted at merger
      ngsq=ng*ng
      iout=1
#ifdef PAIRS
      Fold=Fmax(index(ngtot-1000))  ! first cleaning of pair list
      nptm=0                    ! number of pairs of groups still to merge
      njump=0
#endif
      do igrp=1,ngrpmax
         mass(igrp)=0
         pointer(igrp)=0
         bottom(igrp)=0
c FOR THE MERGER TREES
         MAJORZ(IGRP)=-1      
         T_ACC(IGRP)=-1
         T_APPEAR(IGRP)=-1
         GR_LL(IGRP)=-1
         HALO_APP(IGRP)=-1
         MCENTR(IGRP)=-1
         MASS_AT_MERGER(IGRP)=0
         MERGED_WITH(IGRP)=-1
c
         do ia=1,3
            centres(ia,igrp) =0.
            velgrp (ia,igrp) =0.
#ifdef SPIN
            spin   (ia,igrp) =0.
#endif
         enddo
      enddo
      pointer(1)=ngtot+1        ! filaments are not grouped!
      bottom(1)=ngtot+1
c
      do i=1,ngtot
         group_ID(i)=0
         link_list(i)=0
      enddo
c
      do i=1,6
         nm(i)=0                ! number of mergers of i groups
      enddo
#ifdef PAIRS
c
c Reads info on pair checking from file
c
      open(10,file='fragment.pair',status='unknown')
      read (10,*,end=23)mmin_pair
      read (10,*)Fstart
      read (10,*)deltaF
      read (10,*)njmax
      close(10)
      write(31,*)'Read check-pair parameters from file fragment.pair'
      write(31,*)'F_start = ',Fstart
      write(31,*)'delta_F = ',deltaF
      write(31,*)'minimum mass = ',mmin_pair
      write(31,*)'check done after each ',njmax,' steps'
      if (mmin_pair.lt.MASSMIN) then
         write(31,*)'WARNING: mmin_pair < MASSMIN'
         write(31,*)'Forcing mmin_pair=MASSMIN'
         mmin_pair=MASSMIN
      endif
      call flush(6)
      call flush(31)
      goto 24
 23   print *,'Please create the fragment.pair file'
      print *,'  or compile fragment WITHOUT the -DPAIRS option'
      stop
 24   continue
#endif
c
c This defines the number of neighbours considered
c
c In this case all the 26 neighbouring points are considered
c (the central one is obviously excluded)
c
      if (nv.eq.26) then
         do i=-1,1
            do k=-1,1
               do j=-1,1
                  if (i.eq.0.and.j.eq.0.and.k.eq.0) then
                     mask(i,j,k)=.false.
                  else
                     mask(i,j,k)=.true.
                  endif
               enddo
            enddo
         enddo
c
c In this case considers only 6 neighbouring points
c
      else if (nv.eq.6) then
         do i=-1,1
            do k=-1,1
               do j=-1,1
                  mask(i,j,k)=.false.
               enddo
            enddo
         enddo
         mask(-1,0,0)=.true.
         mask(1,0,0)=.true.
         mask(0,-1,0)=.true.
         mask(0,1,0)=.true.
         mask(0,0,-1)=.true.
         mask(0,0,1)=.true.
      else
         stop 'wrong nv'
      endif
c
c Goes through the points in order of descending inverse collapse time
c
      print *,'Starting the fragmentation process'
      call flush(6)
c
c calculates the number of steps required
c
      do iz=ngtot,1,-1
         if (Fmax(index(iz)).lt.Flim) goto 77
      enddo
 77   nstep=ngtot-iz
      print *,'Number of steps required: ',nstep
      write(31,*)'Number of steps required: ',nstep
      call flush(6)
      call flush(31)
      nstep_p=nstep/20
c
c ************************************************************************
c START OF THE CYCLE ON POINTS
c ************************************************************************
      do iz=ngtot,1,-1
c
c no more collapsed points? exit!
c
         if (Fmax(index(iz)).lt.Flim) goto 99
c
c Output?
c
         if (Fmax(index(iz)).lt.fout(iout)) then
            call out_write(lbox,zout(iout),out_flag)
            call mf(lbox,zout(iout))
            iout=iout+1
         endif
c
         k=ngtot-iz+1
         perc=k/(nstep_p)*5
         if (mod(k,nstep_p).eq.0) then
            print 461,perc,Fmax(index(iz)),inverse_grow(1./Fmax(index(iz)))
            call flush(6)
         endif
 461     format('*** ',i3,'% Done, F =',f6.2,',  z = ',f6.2)
c
c initializations
c
         neigrp=0               ! number of neighbouring groups
         nf=0                   ! number of neighbouring filament points
         accrflag=0             ! if =1 all the neighbouring filaments
                                !   are accreted 
         do in=1,nv
            neigh(in)=0
         enddo
c
c grid coordinates from the index
c
         k=1+(index(iz)-1)/ngsq
         kk=index(iz)-1-(k-1)*ngsq
         j=1+kk/ng
         i=1+(kk-(j-1)*ng)
c
c Check limits
c
         if (ilim1.ne.0) then
            if (i.lt.ilim1.or.i.gt.ilim2.or
     $         .j.lt.jlim1.or.j.gt.jlim2.or
     $         .k.lt.klim1.or.k.gt.klim2) goto 88
         endif
c
c Groups of neighbouring points
c
         nn=0
         do k1=-1,+1
            do j1=-1,+1
               do i1=-1,+1
                  if (mask(i1,j1,k1)) then
                     i2=ipbc(i+i1,ng)
                     j2=ipbc(j+j1,ng)
                     k2=ipbc(k+k1,ng)
                     nn=nn+1
                     neigh(nn)=group_ID(i2+(j2-1)*ng+(k2-1)*ngsq)
c list of touching points that are in filaments (not counted as groups)
c NB: IT ASSUMES THAT GROUP 1 CONTAINS FILAMENTS
                     if (neigh(nn).le.1.and.neigh(nn).ne.0) then
                        nf=nf+1
                        neigh(nn)=0
                        fil_list(1,nf)=i2
                        fil_list(2,nf)=j2
                        fil_list(3,nf)=k2
                     endif   
                  endif
               enddo
            enddo
         enddo
c
c finds neighbouring groups
c
         call clean_list(nv,neigh)
c
c Number of neighbours, groups and filaments
c
         do in=1,nv
            if (neigh(in).le.1) goto 78
         enddo
 78      neigrp=in-1
c
c Is the point isolated?
c
c **********************************************************************
c                       FIRST CASE: PEAK
c **********************************************************************
         if (neigrp.eq.0.and.nf.eq.0) then
c
c **********
c new group!
c **********
c
            ngroups=ngroups+1
            if (ngroups.gt.ngrpmax) then
               print *,'Increase ngrpmax!',ngroups,ngrpmax
               call flush(6)
               stop
            endif
c
            centres(1,ngroups)=i-.5
            centres(2,ngroups)=j-.5
            centres(3,ngroups)=k-.5
            velgrp(1,ngroups)=vx(index(iz))
            velgrp(2,ngroups)=vy(index(iz))
            velgrp(3,ngroups)=vz(index(iz))
            mass(ngroups)=1
            group_ID(index(iz))=ngroups
            pointer(ngroups)=index(iz)
            bottom(ngroups)=index(iz)
            link_list(index(iz))=index(iz)
            GR_LL(NGROUPS)=group_ID(index(iz))
            HALO_APP(NGROUPS)=NGROUPS
c **********************************************************************
c                       SECOND CASE: 1 GROUP
c **********************************************************************
         else if (neigrp.eq.1) then
c
c Else, if the points touches only one group, check whether to accrete the 
c point on it
c
            call accr_cond(i,j,k,vx(index(iz)),vy(index(iz)),vz(index(iz)),
     $           Fmax(index(iz)),neigh(1),d2,r2)
            if (d2.lt.r2) then
c
c *********************
c accretion on a group!
c *********************
c
               accrg=accrg+1
               accrflag=1
               to_group=neigh(1)
               call accretion(to_group,i,j,k,index(iz),Fmax(index(iz)),lbox)
            else
c
c In this case the point is a filament
c
c *********
c filament!
c *********
c
               mass(1)=mass(1)+1
               group_ID(index(iz))=1
               link_list(index(iz))=index(iz)
            endif
c
c **********************************************************************
c                       THIRD CASE: >1 GROUP
c **********************************************************************
         else if (neigrp.gt.1) then
c
c In this case the point touches more than one group
c
c *********************
c accretion on a group?
c *********************
c
            best_ratio=(10.*ng)**2
            accgrp=0
            do ig1=1,neigrp
               call accr_cond(i,j,k,vx(index(iz)),vy(index(iz)),vz(index(iz)),
     $              Fmax(index(iz)),neigh(ig1),d2,r2)
               ratio=d2/r2
               if (ratio.lt.1..and.ratio.lt.best_ratio) then
                  best_ratio=ratio
                  accgrp=ig1
               endif
            enddo
            if (accgrp.gt.0) then
               accrg=accrg+1
               accrflag=1
               to_group=neigh(accgrp)
               call accretion(neigh(accgrp),i,j,k,index(iz),Fmax(index(iz)),lbox)
            endif
c
c Then checks whether the groups must be merged together
c
            nmerge=0
            do ig1=1,neigrp
               do ig2=1,ig1-1
                  merge(ig1,ig2)=0
                  call merge_cond(Fmax(index(iz)),neigh(ig1),neigh(ig2),
     $                 merge_flag)
                  if (merge_flag.eq.1) then
                     merge(ig1,ig2)=1
                     nmerge=nmerge+1
#ifdef PAIRS
                  else if (mass(neigh(ig1)).gt.mmin_pair.and
     $                    .mass(neigh(ig2)).gt.mmin_pair) then
c
c If the merging condition is not satisfied, then records the pair
c 
                     nptm=nptm+1
                     if (nptm.gt.npair) stop 'Increase npair'
                     pairs(1,nptm)=min(neigh(ig1),neigh(ig2))
                     pairs(2,nptm)=max(neigh(ig1),neigh(ig2))
#endif
                  endif
               enddo
            enddo
c
            if (nmerge.gt.1.and.accgrp.eq.0) nwei1=nwei1+1
c
c ******************
c merging of groups!
c ******************
c
c The group number of the largest group is preserved
c
            if (nmerge.gt.0) then
               nmeff=0
               do ig1=1,neigrp
                  do ig2=1,ig1-1
                     if (merge(ig1,ig2).eq.1.and.neigh(ig1).ne.neigh(ig2)) then
c
                        if (mass(neigh(ig1)).gt.mass(neigh(ig2))) then
                           call merge_groups(neigh(ig1),neigh(ig2),Fmax(index(iz)),lbox)
                           large=neigh(ig1)
                           small=neigh(ig2)
                           if (to_group.eq.small) to_group=large
                           do ig3=1,neigrp
                              if (neigh(ig3).eq.small) neigh(ig3)=large
                           enddo
                           nmeff=nmeff+1
                        else
                           call merge_groups(neigh(ig2),neigh(ig1),Fmax(index(iz)),lbox)
                           small=neigh(ig1)
                           large=neigh(ig2)
                           if (to_group.eq.small) to_group=large
                           do ig3=1,neigrp
                              if (neigh(ig3).eq.small) neigh(ig3)=large
                           enddo
                           nmeff=nmeff+1
                        endif
                     endif
                  enddo
               enddo
c
               nm(nmeff)=nm(nmeff)+1
            endif
c
c If relevant, it tries again to accrete the point
c
            if (accgrp.eq.0) then
               call clean_list(nv,neigh)
c
               neigrp =0
               do while(neigrp.lt.nv .and. neigh(neigrp+1).gt.1)
                  neigrp = neigrp + 1
               enddo
c
               accgrp=0
               best_ratio=(10.*ng)**2
               do ig1=1,neigrp
                  call accr_cond(i,j,k,vx(index(iz)),vy(index(iz)),
     $                 vz(index(iz)),Fmax(index(iz)),neigh(ig1),d2,r2)
                  ratio=d2/r2
                  if (ratio.lt.best_ratio) then
                     best_ratio=ratio
                     accgrp=ig1
                  endif
               enddo
c
               if (best_ratio.lt.1) then
                  accrg=accrg+1
                  accrflag=1
                  to_group=neigh(accgrp)
                  call accretion(neigh(accgrp),i,j,k,index(iz),Fmax(index(iz)),lbox)
               else
c
c If the point has not been accreted at all:
c
c *********
c filament!
c *********
c
                  mass(1)=mass(1)+1
                  group_ID(index(iz))=1
                  link_list(index(iz))=index(iz)
c
                  if (nmerge.gt.1) nwei2=nwei2+1
               endif
c end of accretion if
            endif
c **********************************************************************
c                       FOURTH CASE: FILAMENTS
c **********************************************************************
         else
            mass(1)=mass(1)+1
            group_ID(index(iz))=1
            link_list(index(iz))=index(iz)
c
c end of cases
c
         endif
c
c Checks whether to accrete all the neighbouring filaments
c
         if (accrflag.eq.1) then
            do ifil=1,nf
               indx=fil_list(1,ifil)+(fil_list(2,ifil)-1)*ng+
     $              (fil_list(3,ifil)-1)*ngsq
               call accretion(to_group,fil_list(1,ifil),fil_list(2,ifil),
     $              fil_list(3,ifil),indx,Fmax(index(iz)),lbox)
               mass(1)=mass(1)-1
            enddo
         endif
c
c
#ifdef PAIRS
c
c **********************************************************************
c Check for merging pairs
c **********************************************************************
c
         if (nptm.gt.0.and.
     $        (Fmax(index(iz  )).lt.Fold-deltaF.or
     $        .Fmax(index(iz-1)).lt.Flim       .or
     $        .Fmax(index(iz-1)).lt.fout(iout))) then
            njump=njump+1
            Fold=Fold-deltaF
c
c First stage of cleaning: if the group has merged we consider the group it
c has merged into.  If the pair has already merged it is removed
c
            do i=1,nptm
               pairs(1,i)=HALO_APP(pairs(1,i))
               pairs(2,i)=HALO_APP(pairs(2,i))
               if (pairs(1,i).eq.pairs(2,i)) then
c In this case the groups have already merged
                  pairs(1,i)=0
                  pairs(2,i)=0
               endif
            enddo
c
c Second stage of cleaning: the list is ordered and duplicates are removed
c NB: nptm is updated
c
            call clean_list_2(pairs,npair,nptm)
c
            do i=1,nptm
               if (pairs(1,i).eq.0) goto 1555
            enddo
 1555       nptm=i-1
c
c Checks merging condition of groups and forces it if necessary
c
            if ((njump.eq.njmax                 .or
     $          .Fmax(index(iz-1)).lt.Flim      .or
     $          .Fmax(index(iz-1)).lt.fout(iout))
     $          .and.Fmax(index(iz)).lt.Fstart   ) then
c
               write(31,*)'Checking merging condition for ',nptm,' groups'
               njump=0
               npmerge=0
               do i=1,nptm
                  pairs(1,i)=HALO_APP(pairs(1,i))
                  pairs(2,i)=HALO_APP(pairs(2,i))
                  if (pairs(1,i).eq.pairs(2,i)) then
                     pairs(1,i)=0
                     pairs(2,i)=0
                     goto 2727
                  endif
c
                  call merge_cond(Fmax(index(iz)),pairs(1,i),pairs(2,i),merge_flag)
c
                  if (merge_flag.eq.1) then
                     npmerge=npmerge+1
                     if (mass(pairs(1,i)).gt.mass(pairs(2,i))) then
                        call merge_groups(pairs(1,i),pairs(2,i),Fmax(index(iz)),lbox)
                     else
                        call merge_groups(pairs(2,i),pairs(1,i),Fmax(index(iz)),lbox)
                     endif
                     pairs(1,i)=0
                     pairs(2,i)=0
                  endif
 2727          enddo
c
               write(31,*)'Number of groups that have been merged: ',npmerge
     $              ,float(npmerge)/float(nptm)
               call flush(31)
c
            else
               if (njump.eq.njmax) njump=0
            endif
         endif
         
#endif
c ************************************************************************
c END OF DO-CYCLE ON COLLAPSED POINTS
c ************************************************************************
 88   enddo
 99   continue
c
c Counts many things
c
      ngr_ex=0
      mmax=0
      do i=2,ngroups
         mmax=max(mass(i),mmax)
         if (pointer(i).gt.0.and.pointer(i).ne.ngtot+1) then
            ngr_ex=ngr_ex+1
         endif
      enddo
      merge_counter=0
      do i=1,6
         merge_counter=merge_counter+nm(i)
      enddo
c
      write(31,*)'Total number of points considered: ',ngtot-iz
      write(31,*)'Total number of groups: ',ngroups
      write(31,*)'Total number of mergers between groups: ',merge_counter
      write(31,*)'Total number of accretion on groups: ',accrg
      write(31,*)'Number of existing groups: ',ngr_ex
      write(31,*)'Largest group mass: ',mmax
      write(31,*)'Statistics of mergers: ',nm
      write(31,*)'Number of points not accreted immediately at merger: ',nwei1
      write(31,*)'Number of points never accreted at merger: ',nwei2
      call flush(6)
      call flush(31)
c
c Bye!
c
      return
      end
c
c
c
      subroutine mf(lbox,z)
c
c Mass function of the groups
c
      implicit none
#ifdef v64
      include 'param_64.inc'
#endif
#ifdef v128
      include 'param_128.inc'
#endif
#ifdef v256
      include 'param_256.inc'
#endif
c      include 'param.inc'
      include 'link.inc'
#ifdef SPIN
      include 'groups_spin.inc'
#else
      include 'groups.inc'
#endif
c
      character kernel*6,label*4,nome*80
      common /per_mf/kernel
c
      integer nbin,nc
      parameter (nbin=40)
      integer ninbin(nbin),i,ibin
      real omega0,omlam,nsp,csp,s8,h
      common /cosmology/omega0,omlam,nsp,csp,s8,h
      real mmin,mmax,unit,mpp,lbox,lmass,deltam,vol,amass
      real x,dm,a,a1,a2,safelog,z
      integer ilim1,ilim2,jlim1,jlim2,klim1,klim2
      real xlim1,xlim2,ylim1,ylim2,zlim1,zlim2
      common /limits/ilim1,ilim2,jlim1,jlim2,klim1,klim2
     $     ,xlim1,xlim2,ylim1,ylim2,zlim1,zlim2
      external safelog
c
      write(31,*)'Calculating the mass function at the redshift ',z
      if (ilim1.eq.0) then
         vol=lbox**3
      else
         vol=(xlim2-xlim1)*(ylim2-ylim1)*(zlim2-zlim1)
      endif
c
      unit=2.778e11*h**2*omega0*lbox**3
      mpp=unit/float(ngtot)
      mmin=log10(10.*mpp)
      mmax=16.5
c
      lmass=0.
      nc=0
      deltam=(mmax-mmin)/float(nbin)
c
      do i=1,nbin
         ninbin(i)=0
      enddo
c
      do i=2,ngroups
         if (pointer(i).gt.0) then
            amass=log10(mass(i)*mpp)
            if (amass.gt.mmin) nc=nc+1
            lmass=max(amass,lmass)
            ibin=int((amass-mmin)/deltam+1.)
            if (ibin.lt.1.or.ibin.gt.nbin) goto 1
            ninbin(ibin)=ninbin(ibin)+1
         endif
 1    enddo
      write(31,*)'Number of large enough objects: ',nc
      write(31,*)'Largest mass: ',10.**lmass
c
c Writes result
c
      if (z.lt.10) then
         write(label,'(f4.2)')z
      else
         write(label,'(f4.1)')z
      endif
      nome='frag.'//label//'.'//kernel//'.mf.out'
      open(10,file=nome,status='unknown')
      do i=1,nbin
         x=mmin+(i-.5)*deltam
         dm=10.**(mmin+i*deltam)-10.**(mmin+(i-1)*deltam)
         a=ninbin(i)/vol/dm
         a1=(ninbin(i)+sqrt(float(ninbin(i))))/vol/dm
         a2=(ninbin(i)-sqrt(float(ninbin(i))))/vol/dm
         a=safelog(a)
         a1=safelog(a1)
         a2=safelog(a2)
         write(10,100)x,a,a1,a2,ninbin(i)
      enddo
      close(10)
      print *,'Written file '//nome
 100  format(4(1x,f15.8),3x,i10)
      call flush(6)
      call flush(31)
c
c Bye!
c
      return
      end
c
c
c
      subroutine accr_cond(i,j,k,vx,vy,vz,Fmax,grp,dd,rr)
c
c Condition for accretion
c
      implicit none
#ifdef v64
      include 'param_64.inc'
#endif
#ifdef v128
      include 'param_128.inc'
#endif
#ifdef v256
      include 'param_256.inc'
#endif
c      include 'param.inc'
#ifdef SPIN
      include 'groups_spin.inc'
#else
      include 'groups.inc'
#endif
c
      integer i,j,k,grp
      real rvir,dd,rr,d2,Fmax,vx,vy,vz
      real dx,dy,dz
      real distance,virial
      external distance,virial
c
c
c
      rvir=virial(mass(grp),Fmax,1)
c
      rr=rvir*rvir
      dd=100.*rr
      dx=distance((i-.5)+vx/Fmax,centres(1,grp)+velgrp(1,grp)/Fmax
     $     ,float(ng))
      if (dx.lt.rvir) then
         dy=distance((j-.5)+vy/Fmax,centres(2,grp)+velgrp(2,grp)/Fmax
     $        ,float(ng))
         d2=dx*dx+dy*dy
         if (d2.lt.rr) then
            dz=distance((k-.5)+vz/Fmax,centres(3,grp)+velgrp(3,grp)/Fmax
     $           ,float(ng))
            d2=d2+dz*dz
            if (d2.le.rr) dd=d2
         endif
      endif
c
      return
      end
c
c
c
      subroutine merge_cond(Fmax,grp1,grp2,merge_flag)
c
c Checks whether two groups must be merged
c
      implicit none
#ifdef v64
      include 'param_64.inc'
#endif
#ifdef v128
      include 'param_128.inc'
#endif
#ifdef v256
      include 'param_256.inc'
#endif
c      include 'param.inc'
#ifdef SPIN
      include 'groups_spin.inc'
#else
      include 'groups.inc'
#endif
c
      integer grp1,grp2,merge_flag
      real rvir,rvir1,rvir2,dd,rr,Fmax
      real dx,dy,dz
      real distance,virial
      external distance,virial
c      
c
c
      merge_flag=0
      rvir1=virial(mass(grp1),Fmax,0)
      rvir2=virial(mass(grp2),Fmax,0)
c
      rvir=max(rvir1,rvir2)
      rr=rvir*rvir
      dx=distance(
     $     centres(1,grp1)+velgrp(1,grp1)/Fmax
     $    ,centres(1,grp2)+velgrp(1,grp2)/Fmax
     $    ,float(ng))
      if (dx.lt.rvir) then
         dy=distance(
     $        centres(2,grp1)+velgrp(2,grp1)/Fmax
     $       ,centres(2,grp2)+velgrp(2,grp2)/Fmax
     $       ,float(ng))
         dd=dx*dx+dy*dy
         if (dd.lt.rr) then
            dz=distance(
     $           centres(3,grp1)+velgrp(3,grp1)/Fmax
     $          ,centres(3,grp2)+velgrp(3,grp2)/Fmax
     $          ,float(ng))
            dd=dd+dz*dz
            if (dd.le.rr) merge_flag=1
         endif
      endif
c
      return
      end
c
c
c
      subroutine merge_groups(grp1,grp2,time,lbox)
c
c Merges grp2 into grp1
c
      implicit none
#ifdef v64
      include 'param_64.inc'
#endif
#ifdef v128
      include 'param_128.inc'
#endif
#ifdef v256
      include 'param_256.inc'
#endif
c      include 'param.inc'
      include 'link.inc'
      include 'merger_new.inc'
#ifdef SPIN
      include 'groups_spin.inc'
#else
      include 'groups.inc'
#endif
c
      integer grp1,grp2,grp(2)
      integer i1,ic
      real lbox
c
      REAL TIME
c
      real pbc
      external pbc
c
c MAJOR MERGING EVENTS
c
      IF (mass(GRP2).gt.mass(GRP1)/2..AND.MASS(GRP2).GT.MASSMIN) THEN
         MAJORZ(GRP1)=TIME
      ENDIF
c
c updates the linking list
c
      grp(1)=grp1
      grp(2)=grp2
c
      i1=pointer(grp2)
      do while (link_list(i1).ne.pointer(grp2))
         group_ID(i1)=grp1
         i1=link_list(i1)
      enddo
      group_ID(i1)=grp1
c
      link_list(bottom(grp1))=pointer(grp2)
      link_list(bottom(grp2))=pointer(grp1)
      bottom (grp1)=bottom(grp2)
      pointer(grp2)=-1
      bottom (grp2)=-1
#ifdef SPIN
c
c updates the spin of the group
c
      call spin_update(ng,time,lbox
     $                ,mass(grp(1)),centres(1,grp(1)),centres(2,grp(1)),centres(3,grp(1))
     $                ,velgrp(1,grp(1)),velgrp(2,grp(1)),velgrp(3,grp(1))
     $                ,spin(1,grp(1)),spin(2,grp(1)),spin(3,grp(1))
     $                ,mass(grp(2)),centres(1,grp(2)),centres(2,grp(2)),centres(3,grp(2))
     $                ,velgrp(1,grp(2)),velgrp(2,grp(2)),velgrp(3,grp(2))
     $                ,spin(1,grp(2)),spin(2,grp(2)),spin(3,grp(2)))
#endif
c
c updates the centre position and masses, and the existence flag
c
      do ic=1,3
         call update(centres(ic,grp(1)),mass(grp(1)),velgrp(ic,grp(1)),
     $               centres(ic,grp(2)),mass(grp(2)),velgrp(ic,grp(2)),ng)
      enddo
c
c UPDATES THE SUBSTRUCTURE IN THE NEW GROUP
c
      if (mass(grp(1)).gt.MASSMIN.and.mass(grp(2)).gt.MASSMIN) then
         CALL UPDATESUBSTRUCT(GRP(1),GRP(2),TIME)
      endif
C
      mass(grp(1))=mass(grp(1))+mass(grp(2))
c
      if (mass(grp(1)).gt.MASSMIN.and.T_APPEAR(grp(1)).eq.-1) 
     $     T_APPEAR(grp(1))=time
c
c Bye!
c
      return
      end
c
c
c
      SUBROUTINE UPDATESUBSTRUCT(G1,G2,TIME)
C
C UPGRADE THE SUBSTRUCTURE OF A GROUP: M(G1)>M(G2) IE G2 --> G1 
C
      IMPLICIT NONE
#ifdef v64
      include 'param_64.inc'
#endif
#ifdef v128
      include 'param_128.inc'
#endif
#ifdef v256
      include 'param_256.inc'
#endif
c      include 'param.inc'
      include 'merger_new.inc'
#ifdef SPIN
      include 'groups_spin.inc'
#else
      include 'groups.inc'
#endif
c
      integer g1,g2,old_i,first_g2
      real TIME
      integer debug
      common /dbg/debug
c
C
C IF GROUPS HAVE NO SUBSTRUCTURE
      IF(GR_LL(G1).EQ.G1.AND.GR_LL(G2).EQ.G2) THEN 
         MCENTR(G1)=MASS(G1)
         MCENTR(G2)=MASS(G2)
         GR_LL(G1)=G2
         GR_LL(G2)=G1
C
C IF G1 HAS SUBSTRUCTURE BUT G2 IS A SINGLEHALO
      ELSEIF(GR_LL(G1).NE.G1.AND.GR_LL(G2).EQ.G2) THEN
c         GR_LL(G2)=GR_LL(G1)
c         GR_LL(G1)=G2
c     new procedure
         gr_ll(g2)=g1
         old_i=g1
         do while (gr_ll(old_i).ne.g1)
            old_i=gr_ll(old_i)
         enddo        
         gr_ll(old_i)=g2
c     end new procedure
         MCENTR(G2)=MASS(G2)
c
C IF G1 IS A SINGLE HALO AND G2 HAS SUBSTRUCTURE (RARE!)
      ELSEIF(GR_LL(G1).EQ.G1.AND.GR_LL(G2).NE.G2) THEN
         OLD_I=G2
         DO WHILE (GR_LL(OLD_I).NE.G2)
            OLD_I=GR_LL(OLD_I)
            HALO_APP(OLD_I)=G1
         ENDDO
         HALO_APP(G2)=G1
         GR_LL(G1)=GR_LL(G2)
         GR_LL(G2)=G1
         MCENTR(G1)=MASS(G1)
C BOTH THE GROUPS HAVE SUBSTRUCTURE
      ELSEIF(GR_LL(G1).NE.G1.AND.GR_LL(G2).NE.G2) THEN
         OLD_I=G2
         DO WHILE (GR_LL(OLD_I).NE.G2)
            OLD_I=GR_LL(OLD_I)
            HALO_APP(OLD_I)=G1
         ENDDO
c         INDX=GR_LL(G1)
c         GR_LL(G1)=GR_LL(G2)
c         GR_LL(G2)=INDX
c new procedure
         first_g2=old_i
         old_i=g1
         do while (gr_ll(old_i).ne.g1)
            old_i=gr_ll(old_i)
         enddo
         gr_ll(old_i)=gr_ll(g2)
c
         gr_ll(g2)=g1
c     end new procedure
c
      ENDIF
c
      HALO_APP(G2)=G1
      T_ACC(G2)=TIME
      MASS_AT_MERGER(G2)=MASS(G1)
      MERGED_WITH(G2)=G1
c
      RETURN
      END
c
c
c
      subroutine accretion(group,i,j,k,indx,F,lbox)
c
c Accretes the point (i,j,k) on the group
c
      implicit none
#ifdef v64
      include 'param_64.inc'
#endif
#ifdef v128
      include 'param_128.inc'
#endif
#ifdef v256
      include 'param_256.inc'
#endif
c      include 'param.inc'
      include 'link.inc'
      include 'merger_new.inc'
#ifdef SPIN
      include 'groups_spin.inc'
#else
      include 'groups.inc'
#endif
c
      integer group,i,j,k,indx
      real Fmax(ngtot),vx(ngtot),vy(ngtot),vz(ngtot),lbox,F
      common /max/Fmax,vx,vy,vz
c
      if(group.le.0 .or. group.gt.ngrpmax)then
         write (*,*) ' error in accretion: '
         write (*,*) group,i,j,k,indx
         stop 'accretion'
      endif
c
#ifdef SPIN
      call spin_update(ng,F,lbox
     $     ,mass(group),centres(1,group),centres(2,group),centres(3,group)
     $     ,velgrp(1,group),velgrp(2,group),velgrp(3,group)
     $     ,spin(1,group),spin(2,group),spin(3,group)
     $     ,1,i-0.5,j-0.5,k-0.5,vx(indx),vy(indx),vz(indx),0.,0.,0.)
#endif
c
      call update(centres(1,group),mass(group),velgrp(1,group),i-.5,1,vx(indx),ng)
      call update(centres(2,group),mass(group),velgrp(2,group),j-.5,1,vy(indx),ng)
      call update(centres(3,group),mass(group),velgrp(3,group),k-.5,1,vz(indx),ng)
c
      mass(group)=mass(group)+1
c
      if (mass(group).gt.MASSMIN.and.T_APPEAR(group).eq.-1) 
     $     T_APPEAR(group)=F
c
      group_ID(indx)=group
c
c Updates the linking list
c
      link_list(bottom(group))=indx
      bottom(group)=indx
      link_list(indx)=pointer(group)
c
c Bye!
c      
      return
      end
c
c
c
      subroutine update(x1,m1,v1,x2,m2,v2,ng)
c
c Updates the centre position of group 1 respecting PBCs
c
      real x1,x2,v1,v2,d
      integer m1,m2,ng
      real distance,pbc
      external distance,pbc
c
      d=abs(x1-x2)
      if (d.le.ng/2) then
c in this case there's no problem
         x1=(x1*m1+x2*m2)/float(m1+m2)
      else
c PBC must be considered
         if (x1.gt.ng/2) then
c in this case xc is in the second half, and x2 -> x2+ng
            x1=(x1*m1+(x2+ng)*m2)/float(m1+m2)
         else
c in this case xc is in the first half, and x2 -> x2-ng
            x1=(x1*m1+(x2-ng)*m2)/float(m1+m2)
         endif
c checks PBC again
         x1=pbc(x1,float(ng))
      endif
c
c velocity
c
      v1=(v1*m1+v2*m2)/float(m1+m2)
c bye!
      return
      end
c
c
c
#ifdef SPIN
      subroutine spin_update(ng,F,lbox
     $     ,m1,q1x,q1y,q1z,v1x,v1y,v1z,s1x,s1y,s1z
     $     ,m2,q2x,q2y,q2z,v2x,v2y,v2z,s2x,s2y,s2z)
c
c Updates the spin of a halo in case of merging or accretion
c
      implicit none
      integer m1,m2,ng,ic,ix,iy,iz
      real F,rng,z,runit,vunit,tmass,lbox
      real z_collapse,t_collapse,t_me
      real q1x,q1y,q1z,v1x,v1y,v1z,s1x,s1y,s1z
      real q2x,q2y,q2z,v2x,v2y,v2z,s2x,s2y,s2z
      real q1(3),v1(3),s1(3),q2(3),v2(3),s2(3),pq2(3)
      real cm(3),vcm(3),rq1(3),rq2(3),rv1(3),rv2(3)
c
      real inverse_grow,Hubble,fomega,pbc,distance,scale,time
      external inverse_grow,Hubble,fomega,pbc,distance,scale,time
c
      q1(1)=q1x
      q1(2)=q1y
      q1(3)=q1z
      v1(1)=v1x
      v1(2)=v1y
      v1(3)=v1z
      s1(1)=s1x
      s1(2)=s1y
      s1(3)=s1z
c
      q2(1)=q2x
      q2(2)=q2y
      q2(3)=q2z
      v2(1)=v2x
      v2(2)=v2y
      v2(3)=v2z
      s2(1)=s2x
      s2(2)=s2y
      s2(3)=s2z
c
      rng=float(ng)
c phisical units
c
c NB TIME IS INVERSE GROWING MODE!!!
c
      z_collapse= inverse_grow(1./F)
      t_collapse= time(z_collapse)
      t_me      = 0.5*t_collapse
      z         = 1./scale(t_me)-1.
      runit     = lbox/rng/(1.+z)
      vunit     = lbox/rng/F*fomega(z)*Hubble(z)/(1.+z)
c compute position and velocity of center of mass
      tmass = float(m1+m2)
      do ic=1,3
         cm(ic)  = 0.0
         vcm(ic) = 0.0
      enddo
c
      do ic=1,3
         pq2(ic) = q2(ic)
         if (abs(q1(ic)-q2(ic)).gt..5*rng)then
            if(q1(ic) .lt. q2(ic))then
               pq2(ic)=pq2(ic)-rng
            else
               pq2(ic)=pq2(ic)+rng
            endif
         endif
         cm(ic)  = pbc((m1*q1(ic)+m2*pq2(ic))/tmass,rng)
         vcm(ic) = (m1*v1(ic)+m2*v2(ic))/tmass
         rq1(ic) = distance(cm(ic),q1(ic),rng)
         rq2(ic) = distance(cm(ic),pq2(ic),rng)
         rv1(ic) = v1(ic)-vcm(ic)
         rv2(ic) = v2(ic)-vcm(ic)
      enddo
      do ix=1,3
         iy=mod(ix,3)+1
         iz=mod(iy,3)+1
         s1(ix) = s1(ix) + s2(ix)
     $        + runit*vunit*(
     $          m1*(rq1(iy)*rv1(iz)-rq1(iz)*rv1(iy))
     $        + m2*(rq2(iy)*rv2(iz)-rq2(iz)*rv2(iy))
     $        )
      enddo
c
c Bye!
c
      s1x = s1(1)
      s1y = s1(2)
      s1z = s1(3)
      return
      end
#endif
c
c
c
      subroutine out_write(lbox,z,out_flag)
c
c Writes the group catalogues and linking list
c
      implicit none
#ifdef v64
      include 'param_64.inc'
#endif
#ifdef v128
      include 'param_128.inc'
#endif
#ifdef v256
      include 'param_256.inc'
#endif
c      include 'param.inc'
      include 'link.inc'
      include 'merger_new.inc'
#ifdef SPIN
      include 'groups_spin.inc'
      integer ic
#else
      include 'groups.inc'
#endif
c
      real Mpart
      common /particle_mass/Mpart
c
      real lbox,z
      integer i,j,out_flag
      character kernel*6,label*4,nome*80
      common /per_mf/kernel
      real c1,c2,c3,mstar
#ifdef SPIN
      real spin_per_unit_mass(3),fact,slope,fact2,random,logmass
      parameter (fact=0.8,slope=0.15)
      external random
#endif
      real pbc,grow,fomega,Hubble,inverse_grow,aM_star
      external pbc,grow,fomega,Hubble,inverse_grow,aM_star
c
c Out_flag = 0: no writing out
c
      if (out_flag.eq.0) return
c
      if (z.lt.10) then
         write(label,'(f4.2)')z
      else
         write(label,'(f4.1)')z
      endif
c
c Outflag = 1, 3 or 4: saves catalogue
c
      if (out_flag.eq.1.or.out_flag.ge.3) then
         write(31,*)'Writing the group catalogue at redshift ',z
         call flush(31)
         nome='frag.'//label//'.'//kernel//'.grp.out'
         open(10,file=nome,status='unknown')
c
         c1=lbox/float(ng)
         c2=grow(z)
         c3=c1*c2*fomega(z)*Hubble(z)/(1.+z)
         mstar=log10(aM_star(z))
c
         do i=2,ngroups
            if (pointer(i).gt.1.and.mass(i).gt.0) then 
#ifdef SPIN
               logmass=log10(mass(i)*Mpart)
               fact2=max(fact-slope*(logmass-mstar),0.)
               fact2=min(fact2,1.)
               do ic=1,3
                  spin_per_unit_mass(ic)=spin(ic,i)/float(mass(i))
     $                 *((1.-fact2)+fact2*random(seed))
               enddo
               write(10,101)i,logmass
     $              ,(centres(j,i)*c1,j=1,3)
     $              ,(pbc((centres(j,i)+velgrp(j,i)*c2)*c1,lbox),j=1,3)
     $              ,(velgrp(j,i)*c3,j=1,3),(spin_per_unit_mass(j),j=1,3)
     $              ,mass(i)
#else
               write(10,100)i,log10(mass(i)*Mpart)
     $              ,(centres(j,i)*c1,j=1,3)
     $              ,(pbc((centres(j,i)+velgrp(j,i)*c2)*c1,lbox),j=1,3)
     $              ,(velgrp(j,i)*c3,j=1,3)
     $              ,mass(i)
#endif
            endif
         enddo
         close(10)
         print *,'Written file '//nome
         call flush(6)
      endif
c
c Out_flag = 4: Saves linking list
c
      if (out_flag.eq.4) then
         write(31,*)'Writing the linking list at redshift ',z
         call flush(31)
         nome='frag.'//label//'.'//kernel//'.lnk.out'
         open(10,file=nome,status='unknown',form='unformatted')
         write(10)ngtot
         write(10)group_ID
         close(10)
         print *,'Written file '//nome
         call flush(6)
      endif
c
c Out_flag = 2, 3, or 4: Saves histories
c
      if (out_flag.ge.2) then
         write(31,*)'Writing group histories at redshift ',z
         call flush(31)
         nome='frag.'//label//'.'//kernel//'.halo.out'
         OPEN(10,FILE=nome,STATUS='unknown')
         DO i=2,ngroups
            IF (MASS(I).gt.MASSMIN) THEN
               if (T_ACC(I).gt.0.) then
                  c1=inverse_grow(1./T_ACC(I))
               else
                  c1=-1.
               endif
               if (MAJORZ(I).gt.0.) then
                  c2=inverse_grow(1./MAJORZ(I))
               else
                  c2=-1.
               endif
               if (T_APPEAR(I).gt.0.) then
                  c3=inverse_grow(1./T_APPEAR(I))
               else
                  c3=-1.
               endif
               WRITE(10,110)I,HALO_APP(I),GR_LL(I),MERGED_WITH(I)
     $              ,MASS(I),MASS_AT_MERGER(I),MCENTR(I),c1,c2,c3
            ENDIF
         ENDDO
         CLOSE(10)
         print *,'Written file '//nome
         call flush(6)
c      
 100  format(1x,i7,1x,f7.4,6(1x,f7.2),3(1x,f9.2),1x,i6)
 101  format(1x,i7,1x,f7.4,6(1x,f7.2),6(1x,f9.2),1x,i6)
 110  format(7(1x,i7),3(1X,F9.4))
      endif
c
c Bye!
c
      return
      end
c
c
c
      SUBROUTINE clean_list(n,arr)
      INTEGER n
      INTEGER arr(n)
      INTEGER i,j
      INTEGER a
      do 12 j=2,n
c
        do i=j-1,1,-1
           if (arr(i).eq.arr(j))arr(j)=0
        enddo
c
        a=arr(j)
        do 11 i=j-1,1,-1
          if(arr(i).gt.0)goto 10
          arr(i+1)=arr(i)
11      continue
        i=0
10      arr(i+1)=a
12    continue
      return
      END
c
c
c
      SUBROUTINE clean_list_2(arr,nmax,n)
      INTEGER n,nmax
      INTEGER arr(2,nmax)
      INTEGER i,j
      INTEGER a,b
      do 12 j=2,n
c
        do i=j-1,1,-1
           if (arr(1,i).eq.arr(1,j).and.arr(2,i).eq.arr(2,j)) then 
              arr(1,j)=0
              arr(2,j)=0
           endif
        enddo
c
        a=arr(1,j)
        b=arr(2,j)
        do 11 i=j-1,1,-1
          if (arr(1,i).gt.0) goto 10
          arr(1,i+1)=arr(1,i)
          arr(2,i+1)=arr(2,i)
11      continue
        i=0
10      arr(1,i+1)=a
        arr(2,i+1)=b
12    continue
      return
      END
c
c
c
      function virial(grp,F,flag)
c
c Gives the virial radius
c
      implicit none
      integer grp,flag
      real virial,rlag,F,zero
      real f_m,f_rm,f_a,f_s,f_ra,espo,grid,corr
      common /per_virial/f_m,f_rm,f_a,f_s,f_ra,espo,grid
      real aLambda
      external aLambda
c
c
c
      rlag=float(grp)**.3333333333333333333333
      if (flag.eq.0) then
c merging
         virial=rlag*f_m + f_rm
      else
c accretion
         corr=(aLambda(rlag*grid))**(0.5*espo)*F**(-espo)
         corr=min(corr,5.)
         zero=f_ra+f_s*rlag*corr
         virial=f_a*rlag+zero
      endif
c
      return
      end
