c Package: PINOCCHIO 1.1
c
c Written by Pierluigi Monaco
c Copyright (C) 2001
c
c
c XPOS: from grid to space (correcting for PBC)
c IPOS: from space to grid (correcting for PBC)
c DISTANCE: PBC-corrected distance between two space points
c IDISTANCE: PBC-corrected distance between two grid points
c PBC: PBC-corrected space position
c IPBC: PBC-corrected grid position
c
c Contains: xpos, ipos, distance, idistance, pbc, ipbc (functions)
c
      function xpos(i,ng,lbox)
c
c space position for grid number i (correcting for pbc)
c
      real xpos,lbox,center
c NB NB NB NB NB
      parameter (center=0.5)
c NB NB NB NB NB
      integer i,ng,i2
      i2=i
      if (i2.gt.ng) i2=i2-ng
      if (i2.lt.1) i2=i2+ng
      xpos=(i2-center)*lbox/float(ng)
      return
      end
c
c
c
      function ipos(x,ng,lbox)
c
c grid number for space position x (correcting for pbc)
c
      real x,lbox,x2
      integer ipos,ng
      x2=x
      if (x2.ge.lbox) x2=x2-lbox
      if (x2.lt.0.) x2=x2+lbox
      ipos=int(x2*ng/lbox)+1
      return
      end
c
c
c
      function distance(x1,x2,lbox)
c
c Givex x1 and x2 in a box of size lbox with PBC, it gives the 
c smallest distance x2-x1
c
      real x1,x2,lbox,distance
      distance=x2-x1
      if (abs(distance).gt.lbox/2.) then
         if (x1.gt.lbox/2.) then
            distance=distance+lbox
         else
            distance=distance-lbox
         endif
      endif
      return
      end
c
c
c
      function idistance(i1,i2,ng)
c
c Givex i1 and i2 in a box of size ng with PBC, it gives the 
c smallest distance i2-i1
c
      integer i1,i2,idistance,ng
      idistance=i2-i1
      if (abs(idistance).gt.ng/2) then
         if (i1.gt.ng/2) then
            idistance=idistance+ng
         else
            idistance=idistance-ng
         endif
      endif
      return
      end
c
c
c
      function ipbc(i,ng)
      integer i,ng,ipbc
      ipbc=i
      if (i.gt.ng) ipbc=ipbc-ng
      if (i.lt.1) ipbc=ipbc+ng
      return
      end
c
c
c
      function pbc(x,lbox)
      real x,pbc,lbox
      pbc=x
      if (x.ge.lbox) pbc=pbc-lbox
      if (x.lt.0.) pbc=pbc+lbox
      return
      end
