c Package: PINOCCHIO 1.1
c
c Written by Pierluigi Monaco
c Copyright (C) 2001
c
c
      subroutine radii(lbox,run)
c
c Sets the smoothing radii
c
      implicit none
#ifdef v64
      include 'param_64.inc'
#endif
#ifdef v128
      include 'param_128.inc'
#endif
#ifdef v256
      include 'param_256.inc'
#endif
c      include 'param.inc'
      real lbox
      real rmin,rmax
      real omega0,omlam,nsp,csp,s8,h
      common /cosmology/omega0,omlam,nsp,csp,s8,h
      real vol,dq,varmin,rsm(nrsmax),var(nrsmax)
      parameter(varmin=-1.1)
      integer filter,nstep,i
      common /smoothing/rsm,var,nstep
      common /smoothing_filter/filter
      common /extrema/rmin,rmax
      character*6 run
      real aLambda,Radius,safelog,grow
      external aLambda,Radius,safelog,grow
c
c Data
c
      include 'run_info.inc'
c
      csp=1.
      call normalization()
      filter=0
      call Lambda_start()
      call grow_start()
      print *,'Lambda started'
      call flush(6)
c
c Smoothing scales
c
      if (ng.eq.256) then
         nstep=26
      else if (ng.eq.128) then
         nstep=15
      else if (ng.eq.64) then
         nstep=10
      else
         print *,'Number of smoothing steps?'
         read *,nstep
      endif
      nstep=min(nstep,nrsmax)
      nstep=max(1,nstep)
      vol=float(ng**3)/2
      dq=lbox/float(ng)
      rmax=Radius(10.**varmin)
      rmin=dq/6.
      print *,'Lambda function started'
      print *,'Largest smoothing radius: ',rmax
      print *,'Smallest smoothing radius: ',rmin
      print *,'Number of smoothing steps: ',nstep
      do i=1,nstep-1
         rsm(i)=10.**(safelog(rmax)-(i-1.)*
     $        (safelog(rmax)-safelog(rmin))/float(nstep))
         var(i)=aLambda(rsm(i))
         print *,i,rsm(i),sqrt(var(i))
         call flush(6)
      enddo
      rsm(nstep)=0.
      var(nstep)=aLambda(dq/10.)
      print *,nstep,rsm(nstep),sqrt(var(nstep))
      return
      end
